#pragma once
#include "VodafoneTestCase.h"

extern const char* gTest21Description;
//const int gTest21Depends[] = {};

class Test21 : public VodafoneTestCase {
   public: 
      Test21(VodafoneUSBModem *m) : VodafoneTestCase(m) {
         _description = gTest21Description;
         _testCaseNumber = 21;
      }
      
      virtual void setupTest() {
         _ussdResponse = (char*)malloc(16*sizeof(char));
      }
   
      virtual bool execute() {
         LOG(_description);
         
         if(_modem->sendUSSD("*#100#",_ussdResponse,16)!=0) {
            LOG("Error sending USSD");
            return false;
         }
         
         LOG("Received USSD response: \"%s\"",_ussdResponse);
         return true;
      }
      
      virtual void endTest() {
         free(_ussdResponse);
      }
      
   private:
      char *_ussdResponse;
};
