#pragma once
#include "VodafoneTestCase.h"
extern const char* gTest22Description;

class Test22 : public VodafoneTestCase {
   public: 
      Test22(VodafoneUSBModem *m) : VodafoneTestCase(m) {
         _description = gTest22Description;
         _testCaseNumber = 22;
      }
      
      virtual void setupTest() {
         _ussdResponse = (char*)malloc(16*sizeof(char));
      }
   
      virtual bool execute() {
         LOG(_description);
         
         if(_modem->sendUSSD(".2890",_ussdResponse,16)!=0) {
            LOG("Error sending USSD");
            return false;
         }
         
         LOG("Expecting \"Unknown command\". Received USSD response: \"%s\"",_ussdResponse);
         return (strcmp(_ussdResponse,"Unknown command")==0);
      }
      
      virtual void endTest() {
         free(_ussdResponse);
      }
      
   private:
      char *_ussdResponse;
};
