#pragma once
#include "VodafoneUSBModem.h"
#include "LogHeader.h"

class VodafoneTestCase {
   public:
      VodafoneTestCase(VodafoneUSBModem *m) : _modem(m) , _lastRunTime(0), _lastRunOutcome(false) {
      }
      
      bool run() {
         setupTest();
         _lastRunOutcome = execute();
         endTest();
         return _lastRunOutcome;  
      }
      
      virtual void setupTest() {
      }
      
      virtual bool execute() {
         LOG("Base class runTest called!");
         return true;
      }
      
      virtual void endTest() {
         
      }
      
   protected:
      VodafoneUSBModem *_modem;
      
   public:
      time_t _lastRunTime;
      bool _lastRunOutcome;
      int _testCaseNumber;
      const char* _description;
};